#ifndef BITSTREAM_H
#define BITSTREAM_H

#include <sys/types.h>

typedef struct {
  u_char *buffer;
  unsigned long cur;
  int buf_pos;
  int num_bits;
  int fd;
  int filepos;
} bitstream;

bitstream *init_bitstream(const char *fname);
u_char read_byte(bitstream *b);
unsigned long read_bits(bitstream *b, int num);
void align_bits(bitstream *b);
unsigned long peek_bits(bitstream *b, int num);


#endif
