% Peter Boettcher
% 18-796
%
% Hackish program to display a YUV file frame-by-frame, overlaying
%  motion vectors -- Requires a matrix called 'vectors' to exist.
%  Each row of the matrix corresponds to a motion vector, and has
%  five elements: frame num, macroblock x & y coords, MV x & y values.

%sizex = 352;
%sizey = 288;
sizex = 176;
sizey = 144;

%f = fopen('akiyo_10_cif.yuv', 'r');
%f = fopen('mobile_10_cif.yuv', 'r');
f = fopen('debug.yuv', 'r');

for i=1:2
yuv = zeros(sizey, sizex, 3);
y = fread(f, [sizex sizey], 'uchar'); y = y';
%u = fread(f, [176 144], 'uchar'); u = u';
%v = fread(f, [176 144], 'uchar'); v = v';
u = 128*ones(sizey/2, sizex/2);
v = 128*ones(sizey/2, sizex/2);

% Expand Cr and Cb frames
yuv(:,:,1) = y;
u = u(:, ceil(.5:.5:length(u)));
yuv(:,:,2) = u(ceil(.5:.5:sizey/2), :);
v = v(:, ceil(.5:.5:sizex/2));
yuv(:,:,3) = v(ceil(.5:.5:sizey/2), :);

% Convert to RGB
yuv = uint8(yuv);
rgbimage = ycbcr2rgb(yuv);
  
% Display
image(rgbimage);
pause;
end

fclose(f);
