/*
   Winnie Kam Wai  
   assumption:  no sending of quantizaton matrix
   long unsigned int is same size as unsigned int

   what do you do when it is all zeros
 */
//--------------------------------------header
#include <assert.h>
#include <math.h>
#include <limits.h>
#include <stdlib.h>
#include  <stdio.h>
#include "vlc_codes_encode/wk_header2.h"
#include "headers.h"
#include "vlc_codes_encode/wk_vlc_table.h"
#include "vlc_codes_encode/add_inc_enc.h"
#include "vlc_codes_encode/b_type_enc.h"
#include "vlc_codes_encode/p_type_enc.h"
#include "vlc_codes_encode/cbp_enc.h"
#include "vlc_codes_encode/chromsize_enc.h"
#include "vlc_codes_encode/lumsize_enc.h"
#include "vlc_codes_encode/dctcoeff_enc.h"
#include "vlc_codes_encode/mv.h"

#include "seq_iface.h"

seq_header * Seq_p;
pt_GOP GOP_p;
pic_header * Pict_p;
pt_slice slice_p;
FILE *wfptr;
FILE *blockfile;
motion_vec_state *enc_mv_st;
int fCode = 2;

#define escape_c 0x01

#define FORW_F_CODE fCode	    /* from picture header */
#define BACK_F_CODE fCode
#define FORW_F	(1 << (FORW_F_CODE - 1))
#define	BACK_F	(1 << (BACK_F_CODE - 1))
#define RANGE_NEG	(-(1 << (3 + FORW_F_CODE)))
#define RANGE_POS	((1 << (3 + FORW_F_CODE))-1)
#define MODULUS		(1 << (4 + FORW_F_CODE))
#define int_ceil_div(a,b,c)   ((b*(c = a/b) < a) ? (c+1) : c)
#define int_floor_div(a,b,c)	((b*(c = a/b) > a) ? (c-1) : c)

//--------------------------------------init buffer
void init_buff(void)
{
  buffer.char_buff = 0;
  buffer.buff_pos = 0;		//0 means empty..counts from 1->8

}

#if 0
void write2file(unsigned int value, int numbits, FILE * wfptr)
{
  static unsigned int current=0;
  static int pos=0;

  while(space < numbits) {
    space += 8;
    fwrite(&current, 1, 1, wfptr);
    current = (current >> 8) & 0x00ffffff;
  }

  current |= 
#endif
#if 0
//---------------------------------------bit util
void write2file(unsigned int value, int bit_amount, FILE * wfptr)
{
  unsigned int space;
  unsigned char result;
  unsigned int total_bit_num = buffer.buff_pos + bit_amount;
  unsigned int shift;
  int temp, count;

//  printf("write to file   %x, %d bits\n", value, bit_amount);

  if (total_bit_num >= 8) {
    if (buffer.buff_pos != 0) {
      shift = 0xFFFFFFFF >> (32 - bit_amount);
      space = 8 - buffer.buff_pos;

      result = (char) ((buffer.char_buff << space) |
		       ((char) ((value >> (bit_amount - space))) &
			(shift >> (bit_amount - space))));

      fwrite(&result, 1, 1, wfptr);
      buffer.buff_pos = 0;
      bit_amount = bit_amount - space;
      buffer.char_buff = 0;
    }
    shift = 0xFFFFFFFF;
    if (buffer.buff_pos == 0 && bit_amount > 0) {
      while (bit_amount >= 8) {
	bit_amount -= 8;
	/* There are more than or equal to 8 wihth bit num */
	result = (unsigned char) (0x0FF & (value >> bit_amount));
	fwrite(&result, 1, 1, wfptr);
      }
      if (bit_amount > 0) {
	buffer.buff_pos = bit_amount;
	while(bit_amount>0  ) {
	  temp=temp|(0x01<<(bit_amount-1));
	  bit_amount--;
	}
	buffer.char_buff = value & temp;
      }
    }
  } else {			/* (  total_bit_num < 8) */
    count = bit_amount;
    buffer.buff_pos += bit_amount;
    while  (( count)>0 )
      {
        temp=temp| (0x01<<(count-1));
        count--;
      }

    buffer.char_buff = (buffer.char_buff << bit_amount) | (value & temp);
  }
}
#endif
void write2file(unsigned int value, int bit_amount, FILE *wfptr)
{
  //cout<<"value entering  function "<<value<<" with  bitamount "
  //  <<bit_amount<<endl;

  unsigned int space;
  unsigned char result;
  unsigned int total_bit_num=buffer.buff_pos+bit_amount;

  if (total_bit_num>=8  )
    {  //cout<<"if there are more than 8 bits now..."<<endl;
    unsigned shift=0xFFFFFFFF;
      if (buffer.buff_pos !=0 )
	{      
	  shift=0xFFFFFFFF>>((32-bit_amount));
	  space= 8-buffer.buff_pos;
	  // cout<<"what's the space left"<< space <<endl;
	  //	  result=(char  )((buffer.char_buff<<space )|  ( char )( ( value>>(bit_amount-space)))) &0x0FF;
	  result =(char   )((buffer.char_buff<<space )|  (( char )( ( value>>(bit_amount-space))) &  ( shift >>(bit_amount-space) )));
	  //the whole bit vaue got or ed..but..i only want some small value..
	  // & 0x0FF );
	  //cout<<" if buffer is initially not empty....the result now is";
	  //cout     <<(unsigned int )result<<endl;
	  fprintf(wfptr,"%c", result  );
	  buffer.buff_pos=0;
	  bit_amount=bit_amount-space; buffer.char_buff=0;
	} 
      shift=0xFFFFFFFF;
      if (buffer.buff_pos==0 &&bit_amount>0)
	{	
	  //cout<<"now the buffer of originally is cleared"
	  //  <<endl;
	  while(bit_amount>=8  )
	    { 
	      // cout<<"if there are more than or equal to 8 wihth bit num"
	      //  <<bit_amount<<"  "<<(unsigned int )(0xFF&(value>>13))<<endl;
	      
	       result=(unsigned char)((0x0FF)&((value)>>(bit_amount-8)));
	       //result=(value & (shift>>(32-bit_amount))>>(bit_amount-8  ));
	       //cout<<" write to file "<<( unsigned  int )result<<endl;
	      fprintf(wfptr,"%c", result  );
	      bit_amount=bit_amount-8;
	    }
	  if (bit_amount<8  && bit_amount>0)
	    {
	      int mask=0x01;
	      int temp_value=0;

	      //cout<<"if there are no more than 8..just sit in buffer"<<bit_amount<<endl;
	      
	      buffer.buff_pos=bit_amount;
	
	      while(bit_amount>0  )
		{
		  //	  temp_value=(temp_value|(value&mask));   
		  //bit_amount--;
		  temp_value=temp_value|(mask<<(bit_amount-1));
		  bit_amount--;
		  //	  cout<<"temp value " <<temp_value<<endl;
		}	
	      //cout<<"temp value"  <<temp_value<<" avlue" <<value<<endl;
	      buffer.char_buff=temp_value & value;  
	      //cout<<" now thebuffer has  "
	      //  <<(unsigned int  )buffer.char_buff<<"with"
	      //  << buffer.buff_pos<<endl;
	    }
	}
    } 
  else/// (  total_bit_num<8)
    {
      unsigned int temp=0; 
      unsigned int  count=bit_amount;

      //cout<<" when the buffer is less than 8  "<<endl; 
      
      buffer.buff_pos=buffer.buff_pos+bit_amount;
      
      //cout<<"buffer's count is "<< (unsigned int)buffer.buff_pos<<endl;
 
      while  (( count)>0 )
	{
	temp=temp| (0x01<<(count-1));
	count--;
	}

       buffer.char_buff=(buffer.char_buff<<bit_amount)|(value&temp );   

       // cout<<" buffer's content is " <<(unsigned int  )buffer.char_buff<<endl;
  
    }   
  //cout<<"//-----------------------------------------"<<endl; 
}


//---------------------------------------bit align
void align_bit(FILE * wfptr)
{
  if (buffer.buff_pos != 0) {
    buffer.char_buff = buffer.char_buff << (8 - buffer.buff_pos);
    fwrite(&buffer.char_buff, 1, 1, wfptr);
    buffer.char_buff = 0;
    buffer.buff_pos = 0;
  }
}

//---------------------------------------fixed length coding
void fixLcode(unsigned int run, int level, FILE * wfptr)
{
  write2file(escape_c, 6, wfptr);
  write2file(run, 6, wfptr);
  if (abs(level) > 127) {
    write2file((level & (0x80FF)), 16, wfptr);
  }
  else
    write2file(level, 8, wfptr);
}


void encode_mv(int rawmv, int *prev) {
  static int tempC;
  static int v, tmp, xq, xr, forw_r_size;
  codeword vlc;

  v = rawmv - *prev;
  if ( v < RANGE_NEG )	    tmp = v + MODULUS;
  else if ( v > RANGE_POS ) tmp = v - MODULUS;
  else tmp = v;
  if(tmp < RANGE_NEG) fprintf(stderr, "ACK problem!!!! %i\n", tmp);
  if(tmp > RANGE_POS) fprintf(stderr, "ACK problem!!!! %i\n", tmp);
  
  if ( tmp >= 0 ) {
    xq = int_ceil_div(tmp, FORW_F, tempC);
    xr = FORW_F - 1 + tmp - xq*FORW_F;
  } else {
    xq = int_floor_div(tmp, fCode, tempC);
    xr = FORW_F - 1 - tmp + xq*FORW_F;
  }
  
  //  printf("MV: %i %i\n", xq, xr);
  if(xq > 0) {
    vlc = mv_table[xq];
    write2file(vlc.word, vlc.bits, wfptr);
    write2file(0, 1, wfptr);
  } else if(xq < 0) {
    vlc = mv_table[-xq];
    write2file(vlc.word, vlc.bits, wfptr);
    write2file(1, 1, wfptr);
  } else write2file(1, 1, wfptr);

  forw_r_size = fCode - 1;
  if ((forw_r_size != 0) && (xq != 0)) {
    write2file(xr, forw_r_size, wfptr);
  }

  *prev = rawmv;
}

void reset_fmv_state()
{
  enc_mv_st->fmv.down = enc_mv_st->fmv.right = 0;
}

void reset_bmv_state()
{
  enc_mv_st->bmv.down = enc_mv_st->bmv.right = 0;
}

int getsize(int num) 
{
  if(num > 127) return 8;
  else if(num > 63) return 7;
  else if(num > 31) return 6;
  else if(num > 15) return 5;
  else if(num > 7) return 4;
  else if(num > 3) return 3;
  else if(num > 1) return 2;
  else if(num) return 1;
  else return 0;
}

//---------------------------------------formating of 8x8 block inside a macroblock
void block_encoding(int *block, macroblock * mb_p, int index, FILE * wfptr)
{
  int run, level;
  codeword temp;
  int dct_dc_diff = block[0];
  unsigned int size;
  int init;
  int count;

  for(count=0; count < 64; count++)
    fprintf(blockfile, "%i ", block[count]);
  fprintf(blockfile, "\n");

  if(block[0] > 255) block[0] = 255;
  if(block[0] < -255) block[0] = -255;

  size = getsize(abs(block[0]));


  if (mb_p->type & 0x010) {		//intra?
    if (index >= 4)		//chr
      temp = chromsize_table[size];
    else			//i<4  //lum
      temp = lumsize_table[size];
    
    write2file(temp.word, temp.bits, wfptr);	//size
    //      cout<<" dct_dc_diff "  <<dct_dc_diff<<endl;
    // cout<<"dct_dct_diff+1 "<<dct_dc_diff<<endl;

    //    printf(" dct_dc_diff = %x \n ", dct_dc_diff);
    //printf(" dct_dc_diff =%x \n", (abs(dct_dc_diff)));
    //printf(" dct_dc_diff =%x \n", ~(abs(dct_dc_diff)));
    if (dct_dc_diff != 0) {
      if (dct_dc_diff > 0)
	write2file(dct_dc_diff, size, wfptr);
      else
	write2file(~(abs(dct_dc_diff)), size, wfptr);
//	write2file(dct_dc_diff & 0x), size, wfptr);
    }
  }
  if (((mb_p->type) & 0x010) == 0x10)
    init = 1;
  else
    init = 0;

  run = 0;
  level = 0;
  for (count = init; count < 64; count++) {
    //      cout<<" the  "<<count<<" th dctcoeff block is  "
    //          <<block[count  ] <<"  "<<count<<endl;
    if (block[count] == 0) {
      run++;
      //      cout<<" 0 with run now" <<run<<endl;  
    }				//      else      

    if (block[count] != 0)	//if spit out the last one
     {
      level = block[count];
      //      cout<<"level"<<level<<"run"<<run<<endl;
      assert(abs(level) < 256);

      if ((abs(level) > 41) || (run > 31)) {
	fixLcode(run, level, wfptr);
      } else {
	temp = dctcoeff_table[(run << 6) | (abs(level))];
	if (temp.word == ERROR) {
	  fixLcode(run, level, wfptr);
	} else {
	  //*********need to change this  ********/
	  if ((count == 0) && ((run == 0) && (abs(level) == 1))) {
	    //              cout<<"need to come here"<<endl;
	    write2file(1, 1, wfptr);
	  } else
	    write2file(temp.word, temp.bits, wfptr);
	  //------------------------------------sign bits
	  if (block[count] < 0)
	    write2file(1, 1, wfptr);
	  else
	    write2file(0, 1, wfptr);
	}			//when it is in bound
      }				//when i tis not fix ed lieng 
      run = 0;
      level = 0;
    }				//---when it is level
  }				//--------end for erro
  write2file(2, 2, wfptr);	//end
  }

//--------------------------------------macroblock layer
//void input_macro_b(macroblock * mb_p, pic_header * pic_p, FILE * wfptr)
void input_macro_b(macroblock * mb_p)
{
  int count;
  int mask = 0x20;
  codeword temp;

  //  while (mb_p->address > 33) {
  //    write2file(mc_escape, 11, wfptr);
  //  mb_p->address = mb_p->address - 33;
  // }
  // temp = add_inc_table[mb_p->address];
  temp = add_inc_table[1];

  write2file(temp.word, temp.bits, wfptr);

  if (Pict_p->type == 1) {
    for (count = 0; count < 2; count++) {
      if (mb_p->type == I_mb_type[count][0]) {
	write2file(I_mb_type[count][1], I_mb_type[count][2], wfptr);
      }
    }
  } else if (Pict_p->type == 2) {
    temp = p_type_table[mb_p->type];
    write2file(temp.word, temp.bits, wfptr);
  } else if (Pict_p->type == 3) {
    temp = b_type_table[mb_p->type];
    write2file(temp.word, temp.bits, wfptr);
  }
  if ((mb_p->type & 0x01) != 0) {	/* Write quantization level */
    write2file(mb_p->quant, 5, wfptr);
  }
  //----motion vectors
  //  cout<<"what's type"<< mb_p->type   <<"  "<<endl;
  if (mb_p->type & MACROMVF_MASK) { /* FW Motion vectors */
    encode_mv(mb_p->fmv.right, &enc_mv_st->fmv.right);
    encode_mv(mb_p->fmv.down, &enc_mv_st->fmv.down);
  }
  if (mb_p->type & MACROMVB_MASK) { /* Backward Motion Vectors */
    write2file(1, 1, wfptr);
    write2file(1, 1, wfptr);
    //    cout<<endl<<"      //motion compensation for next week  =)   "<<endl;   
  }
  //cbp
  if (mb_p->type & 0x08) {
//    fprintf(stderr, "%x ", mb_p->cbp);
    temp = cbp_table[mb_p->cbp];
    write2file(temp.word, temp.bits, wfptr);
  }
  mask = 0x20;
  //    cout<<"what's mbcbp"<< mb_p->cbp   <<"  "<<endl;
  //for (int count=0; count< 6; count++)//change for debuggin
  for (count = 0; count < 6; count++) {
    if (mb_p->cbp & mask) {
      //      cout<<"coding "<<count<<" -th block"<<endl;
      block_encoding(mb_p->blocks[count], mb_p, count, wfptr);
    }
    mask = mask >> 1;
  }
}

//-------------------------------------write slice to file
void write_slice(pt_slice slice_p, FILE * wfptr)
{
  write2file(SLICE_startc_base, 32, wfptr);
  write2file(slice_p->quant_sc, 5, wfptr);
  write2file(0, 1, wfptr);
}

//-------------------------------------input  pic to file
void input_picture(pic_header * Pict_p)
{
  Pict_p->tem_ref = 0;		//random

  Pict_p->type = 1;	//1->3  random
  Pict_p->vbv_delay = 0xFFFF;	//random
  Pict_p->fmv_full = 0;		//random
  Pict_p->fmv_code = fCode;		//random
  Pict_p->bmv_full = 0;		//random
  Pict_p->bmv_code = fCode;		//random
}

//-------------------------------------write pic to file
void write_picture(pic_header * Pict_p, FILE * wfptr)
{
  write2file(PIC_startcode, 32, wfptr);
  write2file(Pict_p->tem_ref, 10, wfptr);
  write2file(Pict_p->type, 3, wfptr);
  write2file(Pict_p->vbv_delay, 16, wfptr);

  if (Pict_p->type == 2 || Pict_p->type == 3) {
    write2file(Pict_p->fmv_full, 1, wfptr);
    write2file(Pict_p->fmv_code, 3, wfptr);
    if (Pict_p->type == 3) {
      write2file(Pict_p->bmv_full, 1, wfptr);
      write2file(Pict_p->bmv_code, 3, wfptr);
    }
  }
  //write 0  for no extra info.
  write2file(0, 1, wfptr);
  align_bit(wfptr);
}

//-------------------------------------write GOP to file
void write_GOP(pt_GOP GOP_p)
{
  align_bit(wfptr);
  write2file(GOP_p->group_start_code, 32, wfptr);
  write2file(GOP_p->drop_frame_flag, 1, wfptr);
  write2file(GOP_p->hours, 5, wfptr);
  write2file(GOP_p->minutes, 6, wfptr);
  write2file(0x01, 1, wfptr);	//marker

  write2file(GOP_p->seconds, 6, wfptr);
  write2file(GOP_p->pictures, 6, wfptr);
  write2file(GOP_p->closed_gop, 1, wfptr);
  write2file(GOP_p->broken_link, 1, wfptr);
  align_bit(wfptr);
}

//-------------------------------------input GOP to ele
void input_GOP(pt_GOP GOP_p)
{
  GOP_p->group_start_code = GROUP_startcode;
  //----------GOP values
  GOP_p->drop_frame_flag = 1;	//1 if 29.97
  GOP_p->hours = 0;		//random
  GOP_p->minutes = 0;		//random
  GOP_p->seconds = 0;		//random
  GOP_p->pictures = 0;		//random
  GOP_p->closed_gop = 1;	//random
  GOP_p->broken_link = 0;	//random
}

//-------------------------------------input seq to ele
void input_Seq(seq_header * p_seq)
{
  p_seq->horizontal = 352;
  p_seq->vertical = 288;
  p_seq->aspect = 1;
  p_seq->pic_rate = 4;
  p_seq->bit_rate = 0x03FFFF;
  p_seq->vbv_bufsize = 20;
  p_seq->constrained = 0;
}

//-------------------------------------write seq to file
void write_Seq(seq_header * p_seq, FILE * wfptr)
{
  write2file(SEQ_startcode, 32, wfptr);
  write2file(p_seq->horizontal, 12, wfptr);
  write2file(p_seq->vertical, 12, wfptr);
  write2file(p_seq->aspect, 4, wfptr);
  write2file(p_seq->pic_rate, 4, wfptr);
  write2file(p_seq->bit_rate, 18, wfptr);
  write2file(1, 1, wfptr);
  write2file(p_seq->vbv_bufsize, 10, wfptr);
  write2file(p_seq->constrained, 1, wfptr);
  /* Don't send quantization matrices */
  write2file(0, 1, wfptr);
  write2file(0, 1, wfptr);
}

void write_GOP_header()
{
  write_GOP(GOP_p);
}

void write_new_frame(int pic, int pic_type)
{
  fprintf(stderr, "frame %i\n", pic);
  if(pic != 0) align_bit(wfptr);
  input_picture(Pict_p);
  Pict_p->tem_ref = pic;
  Pict_p->type = pic_type;
  write_picture(Pict_p, wfptr);
  write_slice(slice_p, wfptr);
}

int init_bitstream(char *fname, int horiz, int vert, int qscale)
{
  Seq_p = (seq_header *) malloc(sizeof(seq_header));
  GOP_p = (pt_GOP) malloc(sizeof(GOP));
  Pict_p = (pic_header *) malloc(sizeof(pic_header));
  slice_p = (pt_slice) malloc(sizeof(slice_t));
  //  mb_p = (macroblock *) malloc(sizeof(macroblock));

  init_buff();
  wfptr = fopen(fname, "wb");

  input_Seq(Seq_p);

  Seq_p->horizontal = horiz;
  Seq_p->vertical = vert;
  blockfile = fopen("/tmp/blockfile", "w");
  write_Seq(Seq_p, wfptr);
  input_GOP(GOP_p);
  //  write_GOP(GOP_p, wfptr);

  //  init_sequence_interface(fname, Seq_p->horizontal, Seq_p->vertical, qscale);
  slice_p->quant_sc = qscale;	//random 1->31

  enc_mv_st = (motion_vec_state *) malloc(sizeof(motion_vec_state));
  enc_mv_st->fmv.right = enc_mv_st->fmv.down = enc_mv_st->bmv.right = 
    enc_mv_st->bmv.down = 0;

  return(0);
}

void end_bitstream(void)
{
  align_bit(wfptr);
  write2file(0x01B7, 32, wfptr);
  fprintf(stderr, "\n");
  fclose(wfptr);
  fclose(blockfile);
}

#if 0
//-------------------------------------------
int main(int argc, char **argv)
{
  FILE *wfptr;
  seq_header * Seq_p;
  pt_GOP GOP_p;
  pic_header * Pict_p;
  pt_slice slice_p;
  macroblock *mb_p;
  int pic=-1;
  int qscale = 8;

  if((argc != 5) && (argc != 6)) {
    fprintf(stderr, "Usage: encode filename x y outfile <quant>\n");
    exit(-1);
  }
  if(argc == 6) {
    qscale = atoi(argv[5]);
  }

  wfptr = fopen(argv[4], "wb");


  Seq_p = (seq_header *) malloc(sizeof(seq_header));
  GOP_p = (pt_GOP) malloc(sizeof(GOP));
  Pict_p = (pic_header *) malloc(sizeof(pic_header));
  slice_p = (pt_slice) malloc(sizeof(slice_t));
  mb_p = (macroblock *) malloc(sizeof(macroblock));

  init_buff();

  input_Seq(Seq_p);

  Seq_p->horizontal = atoi(argv[2]);
  Seq_p->vertical = atoi(argv[3]);


  write_Seq(Seq_p, wfptr);
  input_GOP(GOP_p);
  //  write_GOP(GOP_p, wfptr);

  init_sequence_interface(argv[1], Seq_p->horizontal, Seq_p->vertical, qscale);
  slice_p->quant_sc = qscale;	//random 1->31

  while((mb_p = get_next_macroblock())) {
    if(mb_p->address == 0) {
      /* New frame */
      pic++;
      fprintf(stderr, "frame %i\n", pic);
      if(pic != 0) align_bit(wfptr);
      if(pic == 10) {
	write_GOP(GOP_p, wfptr);
	pic = 0;
      }
      input_picture(Pict_p);
      Pict_p->tem_ref = pic;
      write_picture(Pict_p, wfptr);
      write_slice(slice_p, wfptr);
      //      reset_slice();
    }
    input_macro_b(mb_p, Pict_p, wfptr);
  }

  //end: for each slice
  align_bit(wfptr);
  write2file(0x01B7, 32, wfptr);
  fprintf(stderr, "\n");

  return(0);
}
#endif
//===================================end of main

