#ifndef HEADERS_H
#define HEADERS_H

/* Masks for macroblock-type variable */
#define MACROQUANT_MASK 0x01
#define MACROMVF_MASK 0x02
#define MACROMVB_MASK 0x04
#define MACROPATTERN_MASK 0x08
#define MACROINTRA_MASK 0x10

typedef struct {
  int horizontal, vertical, aspect, pic_rate, vbv_bufsize;
  int bit_rate, constrained;
} seq_header;

typedef struct {
  unsigned int drop_frame_flag :1;
  unsigned int hours :5;
  unsigned int minutes :6;
  unsigned int marker :1;
  unsigned int seconds :6;
  unsigned int pictures :6;
} time_code;

typedef struct {
  int tem_ref, type, vbv_delay, fmv_full, fmv_code, bmv_full, bmv_code;
} pic_header;
  
typedef struct {
  int right, down;
} motion_vec;

typedef struct {
  motion_vec fmv, bmv;
} motion_vec_state;

typedef struct {
  int address;
  int type;
  int quant;
  motion_vec fmv, bmv;
  int cbp;
  int *blocks[6];
} macroblock;

typedef struct {
  int *y;
  int *u;
  int *v;
  int picref;
} frame_t;

#endif
