#include "parse.h"
#include "xdisplay.h"
#include "reconstruct.h"

extern int *displaybuffer;
extern display_t *display_state;

int main(int argc, char **argv) {
  bitstream *b;
  u_char c;
  //  int **display_ptr;
  seq_header *seq;
  
  pic = (pic_header *)malloc(sizeof(pic_header));

  b=init_bitstream(argv[1]); 
  //    b=init_bitstream("/dosc/windows/desktop/bb.mpg");
  init_mb();
    


  while(1) {
    c=find_start_code(b);
    switch(c) {
    case 0xb8: parse_GOP(b); break;
    case 0x00: {
      update_image();
      parse_picture(b); 
      break;}
    case 0xb3: {
      seq = parse_sequence(b); 
      /* Call display_init with X and Y size in pixels */
      display_state = display_init(seq->horizontal, seq->vertical);
       /* Make a 1-D array of integers the size of the image */
      displaybuffer = (int*)malloc(seq->horizontal*seq->vertical*sizeof(int));
      *(display_state->data_ptr) = displaybuffer;
      init_reconstruct(seq);
      update_image();
      break;
    }
    case 0xb2: parse_userdata(b); break;
    case 0xb5: parse_extension(b); break;
    case 0xb7: {
      fprintf(stderr, "Sequence end, exiting\n");
      exit(0);
    }
    case 0xb4: {
      fprintf(stderr, "Error start code found, exiting\n");
      exit(0);
    } 
    case 0x01 ... 0xAF: parse_slice(b, c); break;
    default:
      fprintf(stderr, "Bogus start code!\n");
      exit(-1);
    }

    handle_xevents();
  }
}
