/***********************************************************************
 * Image reconstruction block 
 * 
 * 18-796: Multimedia Systems
 * Group Members: Peter Boecher
 *                Wai Kam
 *                Henele Adams
 *
 *
 ***********************************************************************/

#ifndef _HIA_RECONSTRUCT_H
#define _HIA_RECONSTRUCT_H

#include <stdlib.h>

#include "headers.h"
#include "block_utils.h"
#include "quantize.h"
#include "fast_2d_dct.h"
#include "xdisplay.h"

typedef struct {
  seq_header *header;

  int quantizer_scale;
  int dct_dc_y_past;
  int dct_dc_cb_past;
  int dct_dc_cr_past;
  
  int macroblock_address;
  int past_intra_address;         /* to find out if blocks were skipped */

  int scan_length;         /*Number of raster scan blocks */
  int hscan_length;        /*horiz size in blocks */
  int vscan_length;

  int ***outputpels;     /* outputpels[scan][sub_block][64] */

} reconstruct_state;

reconstruct_state *state;
int *displaybuffer;
display_t *display_state;
void init_reconstruct();
void reset_reconstruct();
void process_macroblock(macroblock *mb, frame_t frame, frame_t ref);
void yuv_blocks_to_rgb_buffer();

#endif
