#ifndef _HIA_SEQ_IFACE_H
#define _HIA_SEQ_IFACE_H

#include <stdio.h>
#include <stdlib.h>
#include "headers.h"
#include "block_utils.h"
#include "fast_2d_dct.h"
#include "quantize.h"

typedef struct {
  FILE *YUV_sequence;
  int height, width;
  int scan_width, scan_height, scan_length;

  int dct_dc_y_past;
  int dct_dc_cb_past;
  int dct_dc_cr_past;
  int past_intra_address;
  int macroblock_address;
  int quantizer_scale;

  unsigned char *Y_buffer;
  unsigned char *U_buffer;
  unsigned char *V_buffer;

  macroblock *usual_macroblock;
  
  int head, tail;
} seq_iface;

typedef struct {
  unsigned char *y;
  unsigned char *u;
  unsigned char *v;
  int picref;
} char_frame_t;

seq_iface *seq_iface_state;
frame_t i_ref, p_ref;

void init_sequence_interface(char *filename, int width, int height, int qscale);
void set_quant(int quantize_level);
macroblock *get_next_macroblock();
void reset_slice();

#endif
