#ifndef _WK_HEADER_H
#define _WK_HEADER_H


#define long32 unsigned long
#define SEQ_startcode 0x000001B3
#define  GROUP_startcode 0x000001B8
#define  PIC_startcode 0x00000100
#define SLICE_startc_base 0x00000101
#define TRUE 1
#define FALSE 0
#define ERROR INT_MAX
#define mc_escape  0x08
#define Ipic_type  0x01
#define Ppic_type  0x02
#define Bpic_type 0x03

typedef  struct codeword{
  unsigned int word;
  unsigned int bits;
}codeword;

typedef struct  seq{
  unsigned int seq_start_code;
  int horizontal, vertical, aspect, pic_rate, vbv_bufsize, marker;
  unsigned int  bit_rate, constrained;
  int load_non_intra_q;
  int load_intra_q;
}seq, *pt_seq  ;

typedef struct  GOP{
  long32 group_start_code;
  //time code
  unsigned int drop_frame_flag:1;
  unsigned int hours :5;
  unsigned int minutes :6;

  unsigned int marker :1;
  unsigned int seconds :6;
  unsigned int pictures :6;
  //--
  unsigned int closed_gop:1;
  unsigned  int broken_link:1;
  long32 extension_n_user_data;
}GOP, *pt_GOP;

typedef struct Picture_t{
  unsigned long picture_start_code;
  unsigned int  tem_ref, pic_code_type, vbv_delay, 
    fmv_full, fmv_code,
    bmv_full, bmv_code;
}Picture_t,  *pt_Picture;

typedef struct Buffer_t{
  unsigned char char_buff;
  unsigned int buff_pos;
}Buffer_t, pt_buffer;
Buffer_t buffer;

typedef struct slice_t{
  unsigned long slice_start_code;
  unsigned int quant_sc;
}slice_t,* pt_slice;
//----------------------------
typedef struct {
  int h, hr, v, vr;
} motion_vec;

typedef struct macroblock{
  int address;
  unsigned int mb_type;  //set by user
  int quant;
  motion_vec fmv, bmv;
  int cbp;
  //array blocks[6];  //a array of 6 pointers
  short int * blocks [6];
} macroblock, *pt_macrob;

//-------------------
#endif
